#ifndef TREE_HPP
#define TREE_HPP

#include "node.hpp"

#include <vector>

class Tree {
public:
    // Constructor
    Tree() = delete;
    Tree(double mass, double* positions, double* forces_, double softening, unsigned nParticles, double size, Vector center);
    // Destructor
    ~Tree();
    // Update force on a particle
    void updateForce(unsigned particle);
    // Update tree
    void update();

private:
    Node* root_;

    double mass_;
    double* positions_;
    double* forces_;
    unsigned nParticles_;
    double softening_;

    double size_;
    Vector center_;

    // allParticles contains all indices, so [0, 1, 2, ..., nParticles_-1]. It should never be changed. 
    List allParticles_;
};

#endif /* TREE_HPP */